/*
** DESCRIPTION: Example for loops and barriers.
** COMPILE:     g++ -fopenmp -o barrier barrier.cpp -lm
** RUN:         export OMP_NUM_THREADS=2
**              time ./barrier
**
** Append the option 'nowait' to the first 'omp' directive!
**  - Why is it allowed???
**  - How doea the execution time of the program change?
*/

#include <iostream>
#include <math.h>
#include <omp.h>

using namespace std;

#define N 10000

float a[N][N];

int main()
{
	int i, j;

#	pragma omp parallel
    {
		int thread = omp_get_thread_num();
//		cout << "Thread " << thread << ": start loop 1\n";
#		pragma omp for private(i,j) nowait
		for (i=0; i<N; i++) {
			for (j=0; j<i; j++) {
				a[i][j] = sqrt(i) * sin(j*j);
			}
		}

//		cout << "Thread " << thread << ": start loop 2\n";
#		pragma omp for private(i,j)
		for (i=0; i<N; i++) {
			for (j=i; j<N; j++) {
				a[i][j] = sqrt(i) * cos(j*j);
			}
		}
//		cout << "Thread " << thread << ": end loop 2\n";
	}
	
	return 0;
}
