/* Compute the sum of all elements in an array, using multiple threads.
 * The master thread creates ont thread for each row and adds the
 * partial sums after the treads terminated.
 */
#include <iostream>
#include <thread>

#define N 5
#define M 1000

void init_array(int array[N][M])
{
	int i,j;
	for (i=0; i<N; i++) {
		for (j=0; j<M; j++) {
			array[i][j] = i+j;
		}
	}
}

void sum_row(int *row, long *res)
{
	int i;
	long sum = 0;

	for (i=0; i<M; i++)
		sum += row[i];

	*res = sum;
}

int main(int argc, char **argv)
{
	int array[N][M];
	int i;
	std::thread threads[N];
	long res[N];
	long sum = 0;

	/* Initialize the array */
	init_array(array);
	/* Create a thread for each row and pass the pointer to the row and the
	   pointer to the result variable as an argument */
	for (i=0; i<N; i++) {
		threads[i] = std::thread(sum_row, array[i], &res[i]);
	}
	/* Wait for the threads' termination and sum the partial results */
	for (i=0; i<N; i++) {
		threads[i].join();
		sum += res[i];
	}
	std::cout << "Sum: " << sum << "\n";
	
	return 0;
}

