#include <iostream>
#include <omp.h>

using namespace std;

int main()
{
	int me;

    // Use at most 2 threads
	omp_set_num_threads(2);

	// Parallel region, 'me' is private
	#pragma omp parallel private(me)
	{
		// Own thread number (0 or 1)
		me = omp_get_thread_num();

		// Now the threads execute different code!
		if (me == 0)
			cout << "Here is the master thread\n";
		else
			cout << "Here is another thread\n";
	}

	return 0;
}

